//
// This program references a wide range of addresses to do a walk over
//   several entries of the Page Table (PT).
// As the pages are referenced, the TLB must be refilled with entries from
//   the PT.
//
// This program needs a large (simulated) RAM.  RAM must be allocated
//   so that the bottom half is "usable memory" and the top half is
//   allocated to the Page Table.  The base address and RAM size must
//   be set on file  vhdl/packageMemory.vhd.
//
//   x_DATA_BASE_ADDR : reg32   := x"00040000";
//   x_DATA_MEM_SZ    : reg32   := x"00020000";
//
// With this much memory, simulations run slowly.  No free lunch.


#include "cMIPS.h"

#define FALSE (0==1)
#define TRUE  !FALSE

#define MAX_RAM ( x_DATA_BASE_ADDR + (x_DATA_MEM_SZ / 2) )

#define NUM_RAM_PAGES  ( (x_DATA_MEM_SZ / 2) / 4096 )


void main(void) {
  int i;
  int *walker;

  // write to the middle of all pages
  walker = (int *)(x_DATA_BASE_ADDR + 1024);

  for( i = 0 ; i < NUM_RAM_PAGES; i++){
    *walker = i;
    walker = (int *)((int)walker + 4096);
  }

  // and now read what was written
  walker = (int *)(x_DATA_BASE_ADDR + 1024);

  for( i = 0 ; i < NUM_RAM_PAGES; i++){
    print( *walker );
    walker = (int *)((int)walker + 4096);
  }
	
  to_stdout('\n');
  to_stdout('o');
  to_stdout('k');
  to_stdout('\n');

}

